#ifndef __VEHICLE_AI_H__INCLUDED__
#define __VEHICLE_AI_H__INCLUDED__

#include <list>

#include "Vehicle.h"


class VehicleAI : public Vehicle
{
protected:
	enum State
	{
		patrol,
		gohome,
		attack,
		evade
	};

	enum EvadeCause
	{
		none,

		vehicle,
		vehicleCentre,
		terrainLeft,
		terrainRight,
		terrainBoth
	};


	State	m_state,
			m_lastState;
	Vector	m_vec_checkpoint,
			m_vec_destinationDirection;
	float	m_fl_checkpointRadius,
			m_fl_fireRange,
			m_fl_stateTimer;
	bool	m_bo_gotDamage;
	Vehicle	*pTarget;

	list<_Object3 *>	objects;


	void		getAnglesToDestination(float &phi, float &theta);
	void		steerToDestination(const float time);


	EvadeCause	haveToEvade(const Vector &vec);
	bool		haveToGoHome();

	void		beginToPatrol();
	void		beginToGoHome();
	void		beginToAttack(Vehicle *_pTarget);
	void		beginToEvade(const EvadeCause ec);

	void		advance_patrol(float time);
	void		advance_goHome(float time);
	void		advance_attack(float time);
	void		advance_evade(float time);


public:
	// Konstruktor mit Parametern.
	VehicleAI(	const string &model,
				const Vector &checkpoint, const float &checkpointRadius, const float &fireRange,
				const float &_fMaxEnginePower = 8.0f, const float &_fMaxArmour = 1000.0f		);


	// berprft sukzessive alle Einflussfaktoren und trifft dann Entscheidungen.
	bool advance(float time);
};


#endif
