#ifndef __FRAMEWORK__APPLICATION_H__INCLUDED__
#define __FRAMEWORK__APPLICATION_H__INCLUDED__

#include "types.h"


FRAMEWORK_BEGIN


//*** class definition
//********************
class Application
{
protected:
	char		**arguments;
	int_t		nArguments,
				nExitCode;

	virtual void	_init(int_t argc, char *argv[]);

	virtual void	onInit();
	virtual void	onExit();

public:
	Application()
	{	nExitCode = 0;	}
	virtual ~Application();

	// initialisation functions
	inline void		init(int_t argc, char *argv[])
	{	_init(argc, argv);
		onInit();			}

	virtual int_t	run() = 0;
	inline int_t	_run()
	{	int_t	nResult = run();
		return nExitCode ? nExitCode : nResult;	}

	virtual void	exit(int_t nCode = 0);
};


FRAMEWORK_END


//*** external variables
//**********************
extern framework::Application	*g_pApp;


#endif
