#ifndef __FRAMEWORK__MODULE_EXPORT_H__INCLUDED__
#define __FRAMEWORK__MODULE_EXPORT_H__INCLUDED__

#include "Version.h"


#ifdef _WINDOWS
#define MODULE_DEFINE(name, version_major, version_minor, version_build)\
	extern "C" const Version	__module_version(name, version_major, version_minor, version_build);\
	extern "C" const Version *	__module_version_get()\
	{	return &__module_version;	}
#else
#define MODULE_DEFINE(name, version_major, version_minor, version_build)\
	extern "C" const Version	__module_version(name, version_major, version_minor, version_build);
#endif

#define MODULE_EXPORT_CLASS(classname, interfacename)\
	extern "C" interfacename *	__module_new##interfacename()\
	{	return new classname();	}\
	extern "C" interfacename *	__module_copy##interfacename(interfacename *ptr)\
	{	return new classname(ptr);	}\
	extern "C" void				__module_delete##interfacename(interfacename *ptr)\
	{	delete ptr;	}

#define MODULE_EXPORT_CLASS_ADVANCED(classname, interfacename)\
	extern "C" void				__module_delete##interfacename(interfacename *ptr)\
	{	delete ptr;	}\
	extern "C" interfacename *	__module_copy##interfacename(interfacename *ptr)\
	{	return new classname(ptr);	}\
	extern "C" interfacename *	__module_new##interfacename


#endif
