#ifndef __GRAPHICS__IMAGE_H__INCLUDED__
#define __GRAPHICS__IMAGE_H__INCLUDED__

#include "Object2.h"
#include "Texture.h"


GRAPHICS_BEGIN


class Image :	public Object2
{
protected:
	Texture::Reference	rTexture;
	GLfloat				fR, fG, fB, fA,
						fX, fY,
						fSX, fSY,
						fLife, fAge,
						fFadeIn, fFadeOut;
	bool				bAging;


	virtual void	_load();
	virtual void	_remove();

	virtual void	_glLoad();
	virtual void	_glRemove();

	virtual void	_glRender();


public:
	Image(	Texture::Reference &_texture,
			const float &_x, const float &_y, const float &_sx = 1.0f, const float &_sy = 1.0f,
			const float &_r = 1.0f, const float &_g = 1.0f, const float &_b = 1.0f, const float &_a = 1.0f	);
	Image(	Texture::Reference &_texture,
			const float &_x, const float &_y, const float &_sx = 1.0f, const float &_sy = 1.0f,
			const float &_r = 1.0f, const float &_g = 1.0f, const float &_b = 1.0f, const float &_a = 1.0f,
			const float &_life = 1.0f, const float &_fadeIn = 0.0f, const float &_fadeOut = 0.0f			);
	virtual ~Image();


	inline void colour(const float &_r, const float &_g, const float &_b, const float &_a = 1.0f)
	{	fR = _r;	fG = _g;	fB = _b;	fA = _a;	}
	inline void	life(const float &_life, const float _fadeIn = 0.0f, const float _fadeOut = 0.0f)
	{	fLife = _life;	fFadeIn = _fadeIn;	fFadeOut = _fadeOut,	bAging = true;	}
	inline void	position(const float &_x, const float &_y)
	{	fX = _x;	fY = _y;	}
	inline void	size(const float &_sx, const float &_sy)
	{	fSX = _sx;	fSY = _sy;	}
	inline void	texture(Texture::Reference &_texture)
	{	rTexture = _texture;	}


	virtual bool	advance(float time);


	virtual void	glReload();

	virtual void	glBind();
};


GRAPHICS_END
#endif
