#ifndef __GRAPHICS__MATERIAL_H__INCLUDED__
#define __GRAPHICS__MATERIAL_H__INCLUDED__

#include <stdio.h>

#include "Texture.h"

/* MilkShape constants */
#define MS_MAX_NAME             32
#define MS_MAX_PATH             256


GRAPHICS_BEGIN


class Material : public GlItem
{
protected:
	char				Name[MS_MAX_NAME],
						DiffuseTexture[MS_MAX_NAME],
						AlphaTexture[MS_MAX_NAME];
	float				Ambient[4],
						Diffuse[4],
						Specular[4],
						Emissive[4],
						Shininess,
						Transparency;
	Texture::Reference	rTexture;


	virtual void	_load();
	virtual void	_remove();

	virtual void	_glLoad();
	virtual void	_glRemove();


public:
	static Material	standard;


	Material();
	Material(float* _Ambient, float* _Diffuse, float* _Specular, float* _Emissive, float _Shininess);
	~Material();

	static Material *	loadFromMs3dAsciiSegment( FILE *file );


	inline void		texture(Texture::Reference _texture)
	{	rTexture = _texture;	}

	inline bool		hasTexture() const
	{	return !rTexture.isEmpty();	}


	virtual void	glReload();

	virtual void	glBind();
};


GRAPHICS_END
#endif
