#ifndef __GRAPHICS__PLANT_H__INCLUDED__
#define __GRAPHICS__PLANT_H__INCLUDED__

#include "Object3.h"

#include "Map.h"


GRAPHICS_BEGIN


class Plant : Object3
{
protected:
	static Material	materials[10];
	static GLuint	nListID;


	virtual void	_load();
	virtual void	_remove();

	virtual void	_glLoad();
	virtual void	_glRemove();

	virtual void	_glRender();


public:
	Plant(const float &x, const float &y, const float &z, const float &size, const float &angle);
	Plant(const Vector &position, const float &size, const float &angle);

	static Group3 *		createField(const Vector &position, const uint_t &id, const float &size, const float &sizex, const float &sizez, const uint_t &count, const Map &terrain);
	static Group3 *		createPlants(const Vector &position, const uint_t &id, const float &size, const float &radius, const uint_t &count, const Map &terrain);


	static inline void	texture(uint_t id, Texture::Reference _texture)
	{	materials[id].texture(_texture);	}


	virtual void	glReload();
};


GRAPHICS_END
#endif
