#ifndef __GRAPHICS__TGA_TEXTURE_H__INCLUDED__
#define __GRAPHICS__TGA_TEXTURE_H__INCLUDED__


/****************************************************************/
// include files
/****************************************************************/
#include <framework/InputBuffer.h>

#include "Texture.h"


GRAPHICS_BEGIN


/****************************************************************/
// TGATexture: a texture created from a .tga file
/****************************************************************/
class TGATexture	: public Texture
{
public:
	class Allocator :	public Texture::Allocator
	{
	public:
		Allocator()
		{	/* nothing to do */	}

		virtual Texture *	_new() const;
		virtual Texture *	_new(const Id *pId) const;
		virtual Texture *	_copy(const Texture *pItem) const;

		virtual Allocator *	__copy() const;
	};

protected:
	typedef	void (TGATexture::*fnLoad)(InputBuffer *);

	const string	strFile;
	uint_t			nImageDataPosition;
	GLuint			nWidthSkip;
	bool			bRLEd;


	/****************************************************************/
	// methods for loading different .tga formats
	/****************************************************************/
	fnLoad	__load;
	void	__load16NoAlpha(InputBuffer *pIB);
	void	__load16(InputBuffer *pIB);
	void	__load24NoAlpha(InputBuffer *pIB);
	void	__load32NoAlpha(InputBuffer *pIB);
	void	__load32(InputBuffer *pIB);

	/****************************************************************/
	// loading and removing textures (from system memory)
	/****************************************************************/
	virtual void		_load();

public:
	TGATexture(const Id &id);
	virtual ~TGATexture()
	{	/* nothing to do */	}
};


GRAPHICS_END
#endif
