#ifndef __GRAPHICS___SDL_THREAD_BASE_H__INCLUDED__
#define __GRAPHICS___SDL_THREAD_BASE_H__INCLUDED__

#include <SDL_thread.h>

#include "SDLConditional.h"


GRAPHICS_BEGIN


DEFINE_EXCEPTION(SDLThreadException, SDLException, "SDL Thread Exception");
DEFINE_EXCEPTION(SDLThreadNotReadyException, SDLThreadException, "SDL Thread Not Ready Exception");


int __SDLThreadBase_run(void *pThread);


class _SDLThreadBase
{
protected:
	enum State
	{
		ready,
		running,
		stopped,
		killed
	};

	SDL_Thread		*sdlThread;
	State			state;
	SDLConditional	condStart;

	void			_init();
	virtual int_t	_run() = 0;

public:
	_SDLThreadBase() :	state(ready)
	{	/* nothing to do */	}
	virtual ~_SDLThreadBase();

	int_t			wait();
	void			kill();

	inline operator SDL_Thread *()
	{	return sdlThread;	}
	inline operator const SDL_Thread *() const
	{	return sdlThread;	}

	friend int __SDLThreadBase_run(void *pThread);
};


GRAPHICS_END
#endif
