#ifndef __GRAPHICS___SDL_TIMER_BASE_H__INCLUDED__
#define __GRAPHICS___SDL_TIMER_BASE_H__INCLUDED__

#include <SDL_timer.h>

#include <framework/types.h>

#include "graphics.h"


GRAPHICS_BEGIN


class _SDLTimerBase
{
protected:
	SDL_TimerID	sdlTimer;
	uint32_t	nIntervalMs;

	void			_setInterval(uint32_t nMs, SDL_NewTimerCallback fnCallback, void *pTimer);

	virtual void	run(uint32_t _nTimeMs) = 0;

public:
	_SDLTimerBase();
	virtual ~_SDLTimerBase();

	inline uint32_t	getInterval() const
	{	return nIntervalMs;	}
	inline void		setInterval(uint32_t _nIntervalMs)
	{	nIntervalMs = _nIntervalMs;	}

	virtual void	cancel();

	inline operator SDL_TimerID()
	{	return sdlTimer;	}
	inline operator const SDL_TimerID() const
	{	return sdlTimer;	}
};


GRAPHICS_END
#endif
