#ifdef _WINDOWS
#include <framework/_windows.h>
#endif

#include <framework/Application.h>
#include <framework/Exception.h>


FRAMEWORK_BEGIN

using namespace std;


void Application::_init(int_t argc, char *argv[])
{
	nArguments = argc;
	arguments = argv;
}

void Application::onInit()
{		}

void Application::onExit()
{		}


Application::~Application()
{		}

void Application::exit(int_t nCode)
{
	nExitCode = nCode;
}


FRAMEWORK_END


#ifndef FRAMEWORK_MAIN_DISABLE
int main(int argc, char *argv[])
{
	if(g_pApp == NULL)
		return 1;

	try
	{
		g_pApp->init(argc, argv);
		return g_pApp->_run();
	}
	catch(framework::Error &e)
	{
		e.report();
		return 2;
	}
	catch(framework::Exception &e)
	{
		e.report();
		return 2;
	}
	catch(exception &e)
	{
#if defined(_WINDOWS)
		MessageBox(NULL, e.what(), "Unhandled Exception", MB_ICONERROR);
#else
		cerr << "unhandled exception: " << e.what() << endl;
#endif
		return 2;
	}
}
#endif
