#include <graphics/SDLMutex.h>


GRAPHICS_BEGIN


SDLMutex::Allocator	SDLMutex::allocator;


SDL_mutex * SDLMutex::Allocator::_new() const
{
	SDL_mutex	*sdlMutex = SDL_CreateMutex();
	if(!sdlMutex)
		throw SDLException(getLastSDLError());
	return sdlMutex;
}

void SDLMutex::Allocator::_delete(SDL_mutex *sdlMutex) const
{	SDL_DestroyMutex(sdlMutex);	}


SDLMutex::~SDLMutex()
{	/* nothing to do */	}


void SDLMutex::P()
{
	if(sdlMutex.isEmpty())
		sdlMutex.create();
	if(SDL_mutexP(*this))
		throw SDLException(getLastSDLError());
}

void SDLMutex::V()
{
	if(sdlMutex.isEmpty())
		sdlMutex.create();
	if(SDL_mutexV(*this))
		throw SDLException(getLastSDLError());
}


GRAPHICS_END
