#include <graphics/SDLThreadedTimer.h>


GRAPHICS_BEGIN


int_t SDLThreadedTimer::_run()
{
	uint32_t	nTimeMsOld;

	while(bContinue)
	{
		condStart.wait();

		nTimeMsOld = nTimeMs;
		nTimeMs = 0;

		state = running;
		run(nTimeMsOld);
		state = stopped;
	}

	return 0;

}

SDLThreadedTimer::SDLThreadedTimer() :	_SDLThreadBase(),
										_SDLTimerBase(),
										bContinue(true),
										nTimeMs(0)
{	_init();	}

SDLThreadedTimer::~SDLThreadedTimer()
{
	// remove the timer
	cancel();

	// stop the thread
	bContinue = false;
	condStart.signal();
	if(state != killed)
		wait();
	sdlThread = NULL;
}


void SDLThreadedTimer::cancel()
{
	_SDLTimerBase::cancel();

	bContinue = false;
	state = killed;
	condStart.signal();
}


uint32_t _SDLThreadedTimer_run(uint32_t nTimeMs, void *_pTimer)
{
	SDLThreadedTimer *pTimer = (SDLThreadedTimer *)_pTimer;

	pTimer->nTimeMs += nTimeMs;
	if(pTimer->state == SDLThreadedTimer::ready || pTimer->state == SDLThreadedTimer::stopped)
		pTimer->condStart.signal();

	if(!pTimer->getInterval())
		pTimer->sdlTimer = NULL;
	return pTimer->getInterval();
}


GRAPHICS_END
